#include "help.h"
#include "reciteword.h"
#include "skin.h"
#include <gdk/gdkkeysyms.h>


extern CReciteWord *g_pReciteWord;
extern struct _Skin Skin;

static void
on_exit_button_clicked (gpointer data)
{
	g_pReciteWord->help_window->close ();
}

static gboolean
on_window_key_press(GtkWidget * window, GdkEventKey * event ,CHelp * parent)
{
	switch (event->keyval)
	{
		case GDK_Return:
		case GDK_Escape:
			parent->exit_button.do_clicked();
			break;
	}
	return true;
}

static gint
on_window_delete_event (GtkWidget * window,GdkEvent *event, CHelp * parent)
{
	parent->close();
	return true;
}

CHelp::CHelp ()
{
	skin_load_help (g_pReciteWord->window);
}

CHelp::~CHelp ()
{
}

void
CHelp::init ()
{
	g_pReciteWord->help_button.set_enable (FALSE);
}

void
CHelp::show ()
{
	init ();

	GtkWidget *fixed;
	showing = TRUE;
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_size_request (window, Skin.help.help.w, Skin.help.help.h);
	gtk_window_set_resizable(GTK_WINDOW (window), FALSE);
	gtk_widget_set_app_paintable(window,TRUE);
	gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (window), "Help");
	gtk_window_set_transient_for (GTK_WINDOW (window),
				      GTK_WINDOW (g_pReciteWord->window));
	gtk_widget_realize (window);

	fixed = gtk_fixed_new ();
	//gtk_fixed_set_has_window(GTK_FIXED(fixed),TRUE);
	gtk_container_add (GTK_CONTAINER (window), fixed);
	gtk_widget_show (fixed);
	SetBackPixmap (fixed, Skin.help.help.p);

	exit_button.create (fixed, Skin.help.exit_button.x,
			    Skin.help.exit_button.y,
			    Skin.help.exit_button.p1,
			    Skin.help.exit_button.p2, NULL,
			    on_exit_button_clicked, NULL);

	/*GtkWidget *viewport;
	viewport = gtk_viewport_new(NULL,NULL);
	//gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport),GTK_SHADOW_NONE);
	gtk_widget_set_size_request(viewport,100,100);
	gtk_fixed_put(GTK_FIXED(fixed),viewport,0,0);
	gtk_widget_show(viewport);*/

	g_signal_connect (G_OBJECT (window), "delete_event",
			  G_CALLBACK (on_window_delete_event), this);
	g_signal_connect (G_OBJECT (window), "key_press_event",
			  G_CALLBACK (on_window_key_press), this);
			  
	gtk_widget_show (window);
	playsound(SND_WIND);
}

void
CHelp::close ()
{
	exit_button.destroy();
	gtk_widget_destroy (window);
	
	showing = FALSE;
	g_pReciteWord->help_button.set_enable (TRUE);
	playsound(SND_WIND);
}
