#include "readword.h"

#include <string>
#include <cstring>
#include <fstream>
#include <map>
using namespace std;


class Cwyabdc
{
	bool havedatafile;
	std::map<string,string> fileMap;
	
	void init_wordlist();
	
	public:
	Cwyabdc ();
	~Cwyabdc ();
	void read(const char *word,PLAY_METHOD method);
};

Cwyabdc::Cwyabdc ()
{
	init_wordlist();
}

Cwyabdc::~Cwyabdc ()
{

}

void Cwyabdc::init_wordlist()
{
	std::ifstream listfile("RealPeopleTTS/works/wordlist999.txt");
	if (listfile.fail())
	{
		havedatafile=false;
		return;
	}	
	havedatafile=true;
	
	string line,word,filename;
	int ndx;
	while (getline(listfile,line))
	{
		ndx=line.find('=');
		if (ndx!=-1)
		{
			word=line.substr(0,ndx);
			filename=line.substr(ndx+1,8);
			fileMap.insert(std::map<string,string>::value_type(word,filename));
		}
	}
}

void Cwyabdc::read(const char *word,PLAY_METHOD method)
{
	if (!havedatafile)
		return;
	char lowerword[256];
	int n=strlen(word);
	for (int i=0;i<n;i++)
		lowerword[i]=tolower(word[i]);
	lowerword[n]='\0';
	string wordstr(lowerword);
	std::map<string,string>::iterator pos = fileMap.find(wordstr);
	if (pos == fileMap.end())
	{
	}
	else
	{
		string wavfile = "RealPeopleTTS/works/";
		wavfile += (* pos).second[0];
		wavfile += "/" + (* pos).second + ".wav";
		play_file (wavfile.c_str(),method);
	}
}

static Cwyabdc wyabdc;

void
readword (const char *word,PLAY_METHOD method=PM_MIX)
{
	if (word && word[0]!='\0')
		wyabdc.read (word,method);
}
