#include "sound.h"
#include <string>

class CSound
{
	bool canplay;
	string filename;

      public:
	  CSound ();
	 ~CSound ();
	void play (SOUND_EVENTS event,PLAY_METHOD method);
};

CSound::CSound ()
{
	canplay=true;
}

void
CSound::play (SOUND_EVENTS event,PLAY_METHOD method)
{
	if (!canplay)
		return;
	switch (event)
	{
		case SND_BUTTONDOWN:
			filename = "modules/buttondown.wav";
			break;
		case SND_BUTTONUP:
			filename = "modules/buttonup.wav";
			break;
		case SND_ANSWEROK:
			filename = "modules/answerok.wav";
			break;
		case SND_ANSWERNO:
			filename = "modules/answerno.wav";
			break;
		case SND_ANSWERNO2:
			filename = "modules/answerno2.wav";
			break;
		case SND_CHORD:
			filename = "modules/chord.wav";
			break;
		case SND_DING:
			filename = "modules/ding.wav";
			break;
		case SND_GUNOK:
			filename = "modules/gunok.wav";
			break;
		case SND_GUNNO:
			filename = "modules/gunno.wav";
			break;
		case SND_TYPE:
			filename = "modules/type.wav";
			break;
		case SND_BACK:
			filename = "modules/back.wav";
			break;
		case SND_WIND:
			filename = "modules/wind.wav";
			break;
		default:
			filename = "";
			break;
	}
	play_file(filename.c_str(),method);
}

CSound::~CSound ()
{
}


static CSound soundevent;

void
playsound (SOUND_EVENTS event,PLAY_METHOD method=PM_MIX)
{
	soundevent.play (event,method);
}
